e<!DOCTYPE html>
<html lang="zxx">

<head>
  <meta charset="utf-8">
  <title>Thomson-Minimal Portfolio</title>

  <!-- mobile responsive meta -->
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

  <!-- ** Plugins Needed for the Project ** -->
  <!-- Bootstrap -->
  <link rel="stylesheet" href="plugins/bootstrap/bootstrap.min.css">
  <link rel="stylesheet" href="plugins/themify/css/themify-icons.css">
  <link rel="stylesheet" href="plugins/counto/animate.css">
  <link rel="stylesheet" href="plugins/aos/aos.css">
  <link rel="stylesheet" href="plugins/owl-carousel/owl.carousel.min.css">
  <link rel="stylesheet" href="plugins/owl-carousel/owl.theme.default.min.css">
  <link rel="stylesheet" href="plugins/magnific-popup/magnific-popup.css">
  <link rel="stylesheet" href="plugins/animated-text/animated-text.css">

  <!-- Main Stylesheet -->
  <link href="css/style.css" rel="stylesheet">

</head>

<body>
  <style>
  body {
      background-color: ##efefef;

  }
  </style>
<!-- Header Start -->

<nav class="navbar navbar-expand-lg  main-nav " id="navbar">
	<div class="container">
	  <a class="navbar-brand" href="simpletemplate/index.html">

      <div align="center">
        <img src="images/logonaty.png" style= "width: 50px" align="center" >

      </div>
	  </a>

	  <button class="navbar-toggler collapsed" type="button" data-toggle="collapse" data-target="#navbarsExample09" aria-controls="navbarsExample09" aria-expanded="false" aria-label="Toggle navigation">
		<span class="ti-align-justify"></span>
	  </button>

		  <div class="collapse navbar-collapse" id="navbarsExample09">
			<ul class="navbar-nav ml-auto">
         <li class="nav-item  active"><a class="nav-link" href="introductiontodigitalfabrication.html">Return</a></li>
			  <li class="nav-item  active"><a class="nav-link" href="index.html">Main Page</a></li>

         <li class="nav-item  active"><a class="nav-link" href="about.html">About Me</a></li>



			   <li class="nav-item"><a class="nav-link" href="https://gitlab.com/flu">Gitlab Repo</a></li>
			</ul>
		</div>
	</div>
</nav>





<!-- Header Close -->




  <div class="container">
<!-- <div class="col-12"> -->

      <!-- </div> -->



<div class="col-lg-12 col-xs-12">
<section class="section blog-post" style="padding: 100px 180px;">
	<div class="container">
		<div class="row">
			<!-- <div class="col-lg-6"> -->
				<article class="single-post">
          <div class= "middle" align="justify">
            <h9> Embedded Programming </h9>

            <h8> 15.4.2020</h8>
            <p></p>
            <p> This week in Fabacademy we have learnt more about how computers and their memory work and we have learnt about their history. The assignment was to program our leds with arduino  using analogwrite/digitalwrite

Program with arduino (libraries) and also with registers, and after, use PlatformIO to program the board. </p>
<p> I have worked with arudino previously in my bachelors at product design course called connected things where I have created a smart wearable. However, back then I have received a lot of help in programming and making the electronics from my teacher. This week, it was nice to refresh my memory and my desire to learn how to code. </p>
<p> Even though I did not have that much interest in Arduino before (despite the project I created), this week I found playing with Arduino fun! Contrary to previous experiences I had, this time I felt like I kind of knew what I was doing. I guess my skills in coding and electronics grow, even though I had not noticed so. </p>
<p> The board I was using this week was Elegoo UNO R3, which is a cheaper version of Arduino Uno. This board's microcontroller is ATMEGA328P-U. This mictrocontroller is almost identical with ATMEGA328 found in Arduino Uno, it has the same  functions and pins, there are slight differences in fabrication. ATMEGA328  ATmega328 is a single-chip microcontroller. It has a modified Harvard architecture 8-bit RISC processor core.</p>
It operates with a 3.3V to 5.5V supply, although we use 5V normally. It has 32K bytes builtin memory and supports 8 bits of data  </P>
<p> Notice, that for the analog read I was using PWM (Pulse Width Modulation) pins, because these pins act both as digital and analog, and allow the user to modulate the width of a pulse to get our required results. </p>
<img src= "images/datasheet.jpg" style= "width: 700px" align="center">

              <p> Example 1 </p>
              <p>  For the first example I have decided to test the board with simple blinking as this was the first time I have used it. I connected the LED using 10K resistor and used pin 13 for digitalWrite as we use digitalWrite in cases where we do not have values ranging for example fading, and the only option is TRUE,FALSE/HIGH,LOW. It worked easily.  </p>
              <video width="700" height="320" controls>
                <source src="images/IMG_4937.mp4" type="video/mp4">

      </video>
              <img src="images/blink.jpg" alt="Arduino1" style="width:100%">

              <p> Example 2</p>
              <p> For the second example I have decided to connect 3 different LEDS and make them fade using analogwrite . Even though in the previous example I have connected the LED into pin 13, this time I had to connect the pins into PWM pins. For this code I have used an example code for fade.  In the first code I have multiplied the section in loop for each led, however I thought that there must be a way to do this without copying the code. Therefore I made 2nd variation of the code that you can also <a href="images/fade1.ino" download>Download here</a>
                <video width="700" height="320" controls>
                  <source src="images/IMG_4954.mp4" type="video/mp4">

        </video>

<p> Comparing the quality of two codes  </p>
                    <img src="images/arduinos.jpg" alt="Arduino1" style="width:100%">


            <p> Example 3</p>
            <p> For the example 3 I have decided to write a code on my own. I wanted to create an alley of LEDS, lighting up one by one from one side and turning off one by one from the other side. </p>
            I knew that for this logic, I will need use condition - for and if. For would be used to include the LEDS- from the lowest pin number to the highest pin number one by one, using ++ (that adds one to the number). If needed to be used for condition that will keep the LEDS on once they light up, and only if they are all HIGH then they would start turning off one by one. For this the for condition was reversed and I used -- (to go down by one).
            One mistake I was doing, was that the first led that lightened up, was never turning off. It is important to include the Pin in condition for example if the pin is pin3, in condition i must say Pin>2,or Pin=>3 only that way pin 3 will be included. </p>
            <img src="images/upanddown.jpg" alt="Arduino1" style="width:100%">

            <video width="700" height="320" controls>
              <source src="images/up.mp4" type="video/mp4">

            </video>
            <video width="700" height="320" controls>
              <source src="images/IMG_4954_2.mp4" type="video/mp4">

            </video>

            <video width="700" height="320" controls>
              <source src="images/IMG_4954_1.mp4" type="video/mp4">

            </video>


<a href="images/upanddown.zip" download>FILE HERE</a>
<p> I tried hard to code the board with Arduino, however I have not managed to do so yet. I will upload any sucessful changes. </p>


	<div class="single-post-content mt-4">
		<!-- <div class="post-meta mb-4">

		</div> -->
		<div class="share mt-4">
			<ul class="list-inline">
				<li class="mb-3">Share Now :</li>
				<li class="list-inline-item"><a href="#"><i class="ti-facebook mr-2"></i> Facebook</a></li>
				<li class="list-inline-item"><a href="#"><i class="ti-twitter mr-2"></i> Twitter</a></li>
				<li class="list-inline-item"><a href="#"><i class="ti-linkedin mr-2"></i> Linkedin</a></li>
				<li class="list-inline-item"><a href="#"><i class="ti-pinterest mr-2"></i> Pinterest</a></li>
			</ul>
		</div>
	</div>
  </article>


</div>
			</div>
		</div>
	</div>
</section>

<section class="footer">
	<div class="container">
		<div class="row ">
			<div class="col-lg-6">
				<p class="mb-0">Copyrights © 2019. Designed & Developed by <a href="themefisher.com" class="text-white">Themefisher</a></p>
			</div>
			<div class="col-lg-6">
				<div class="widget footer-widget text-lg-right mt-5 mt-lg-0">
					<ul class="list-inline mb-0">
						<li class="list-inline-item"><a href="https://www.facebook.com/themefisher" target="_blank"><i class="ti-facebook mr-3"></i></a>
						</li>
						<li class="list-inline-item"><a href="https://twitter.com/themefisher" target="_blank"><i class="ti-twitter mr-3"></i></a>
						</li>
						<li class="list-inline-item"><a href="https://github.com/themefisher/" target="_blank"><i class="ti-github mr-3"></i></a></li>
						<li class="list-inline-item"><a href="https://www.pinterest.com/themefisher/" target="_blank"><i class="ti-pinterest mr-3"></i></a></li>
						<li class="list-inline-item"><a href="https://dribbble.com/themefisher/" target="_blank"><i class="ti-dribbble mr-3"></i></a></li>
					</ul>
				</div>
			</div>
		</div>
	</div>
</section>
<!-- jQuery -->
<script src="plugins/jQuery/jquery.min.js"></script>
<!-- Bootstrap JS -->
<script src="plugins/bootstrap/bootstrap.min.js"></script>
<script src="plugins/aos/aos.js"></script>
<script src="plugins/owl-carousel/owl.carousel.min.js"></script>
<script src="plugins/shuffle/shuffle.min.js"></script>
<script src="plugins/magnific-popup/jquery.magnific-popup.min.js"></script>
<script src="plugins/animated-text/animated-text.js"></script>
<script src="plugins/counto/apear.js"></script>
<script src="plugins/counto/counTo.js"></script>

 <!-- Google Map -->
<script src="plugins/google-map/map.js"></script>
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAkeLMlsiwzp6b3Gnaxd86lvakimwGA6UA&callback=initMap"></script>
<!-- Main Script -->
<script src="js/script.js"></script>

</html>
